package com.junmp.junmpProcess.controller;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.junmp.junmpProcess.common.Result;
import com.junmp.junmpProcess.doc.BpmnDoc;
import com.junmp.junmpProcess.utils.BpmnConvert;
import com.junmp.junmpProcess.vo.ProcessVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import com.junmp.junmpProcess.service.Bussiness.WorkProcessService;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.engine.ProcessEngine;
import org.flowable.engine.ProcessEngineConfiguration;
import org.flowable.engine.repository.Deployment;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.sql.DataSource;

@Slf4j
@RestController
@RequestMapping("/Bpmn")
public class BpmnController implements BpmnDoc {

    @Resource
    private DataSource dataSource;

    @Autowired
    private WorkProcessService ProcessService;
    @Override
    @PostMapping(value = "bpmn/create")

    public Result<String> create(@RequestBody ProcessVO processVO) throws JsonProcessingException {
//        ProcessEngineConfiguration.
        ProcessEngineConfiguration config = ProcessEngineConfiguration.createStandaloneInMemProcessEngineConfiguration();
        config.setDataSource(dataSource);
        config.setDatabaseSchemaUpdate(ProcessEngineConfiguration.DB_SCHEMA_UPDATE_TRUE);

        ProcessEngine processEngine = config.buildProcessEngine();


        //流程定义
        ObjectMapper objectMapper = new ObjectMapper();
        JsonNode processJsonNode = objectMapper.readTree(processVO.getProcessJson());


        ObjectMapper formMapper = new ObjectMapper();
        JsonNode formJsonNode = objectMapper.readTree(processVO.getFormJson());



        //将json转换为bpmn
        BpmnConvert bpmnConvert=new BpmnConvert();
        BpmnModel bpmnModel = bpmnConvert.toBpmn(processJsonNode,formJsonNode);

        Deployment deployment = processEngine.getRepositoryService()
                .createDeployment()
                .addBpmnModel(bpmnModel.getProcesses().get(0).getId()+".bpmn20.xml", bpmnModel)
                .deploy();

        return Result.OK(deployment.getId());
    }

}
